<template>
  <div class="avenir ma4">
    <div class=" f2 lh-solid">Crie seu grupo</div>
    <div class="ph7-l pv4">
      <div class="tl center f5"> Escolha um nome criativo e adicione os demais integrantes do seu grupo
      </div>
    </div>
    <form class="measure-ns center" @submit="onSubmit">
      <label class="db fw6 lh-copy f4 tl pv1" for="email-address">Nome do grupo</label>
      <input id="email-address" v-model="form.name" class="pa2 w-100 ba b--primary" type="text" name="email-address">
      <card class="center ma2 hidden ba mv4">
        <h1 v-if="form.name === ''" class="f3 mv0 pv2 ph3 primary-color">Seu grupo</h1>
        <h1 v-else class="f4 mv0 pv2 ph3 primary-color">{{ form.name }}</h1>
        <div class="pa3 bt">
          <div class="flex flex-wrap justify-start-m">
            <card v-for="participant in form.participants" :key="participant.id" class="hidden ba w-40-ns">
              <div>
                <h3 class="mv2" @click="removeParticipant(participant, $event)">Nome do Participante</h3>
                <p class="  overflow-x-auto">
                  {{ participant.id }}
                </p>
              </div>
            </card>

            <card v-if="form.participants.length < maxParticipants" class="hidden ba w-100 w-40-ns">
              <div class="pa1">
                <button @click="addParticipant">
                  <p>
                    +
                  </p>
                </button>
              </div>
            </card> 
          </div>
        </div>
      </card>

      <card v-if="showSelected" class="center ma2 hidden ba mv4">
        <div v-for="selected in mock.selected" :key="selected.id" class="bb pa2" @click="selectParticipant(selected, $event)"> {{ selected.id }}</div>
      </card>

      <Button :text="'Criar'" @click.native="criarGrupo" />
    </form>

  </div>
</template>

<style>
.avenir {
  font-family: avenir-next;
}
</style>

<script>
import gql from "graphql-tag"
import Button from "~/components/Button.vue"
import Card from "~/components/Card.vue"

const criarGrupoMutation = gql`
  mutation criarGroup($name: String!) {
    insertGroup(name: $name) {
      id
    }
  }
`

const updateSelected = gql`
  mutation atualizarSelected($registered_id: Int!, $group_id: ID!) {
    updateSelected(registered_id: $registered_id, group_id: $group_id) {
      id
    }
  }
`

export default {
  components: {
    Button,
    Card
  },
  data() {
    return {
      maxParticipants: 4,
      form: {
        name: "",
        participants: []
      },
      mock: {
        selected: []
      },
      showSelected: false
    }
  },
  created() {
    console.log(this)
  },
  async mounted() {
    try {
      await this.$apollo
        .query({
          query: gql`
            query {
              allSelecteds {
                id
                registered_id
              }
            }
          `
        })
        .then(({ data }) => (this.mock.selected = data.allSelecteds))
    } catch (e) {
      console.error(e)
      this.error = e
    }
  },
  methods: {
    criarGrupo(evt) {
      evt.preventDefault()
      this.$apollo
        .mutate({
          mutation: criarGrupoMutation,
          variables: {
            name: this.form.name
          }
        })
        .then(data => {
          this.form.participants.map(participant => {
            this.$apollo
              .mutate({
                mutation: updateSelected,
                variables: {
                  registered_id: participant.registered_id,
                  group_id: data.data.insertGroup.id
                }
              })
              .then(res => {
                console.log(res)
              })
          })
        })
    },
    addParticipant(evt) {
      evt.preventDefault()
      this.showSelected = true
    },
    removeParticipant(participant) {
      const index = this.form.participants.indexOf(participant)
      this.form.participants.splice(index, 1)
      console.log(participant.id)
    },
    async onSubmit(evt) {
      evt.preventDefault()
      // update selecteds group_id
      console.log(this.form.name)
    },
    selectParticipant(selected, evt) {
      evt.preventDefault()
      console.log(selected)
      this.form.participants.push(selected)
      this.showSelected = false
    }
  }
}
</script>
